<html>
<head>
<title>OgrePagedWorldSection.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_b4dabe1aeee1fabc669d37783945a897.html">Paging</a>      </li>
      <li class="navelem"><a class="el" href="dir_c90181f353a19ac84e93eaccff6d8392.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgrePagedWorldSection.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgrePagedWorldSection_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Ogre_PagedWorldSection_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Ogre_PagedWorldSection_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePagingPrerequisites_8h.html">OgrePagingPrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre
<a name="l00036"></a>00036 {
<a name="l00069"></a><a class="code" href="classOgre_1_1PagedWorldSection.html">00069</a>     <span class="keyword">class </span><a class="code" href="OgrePagingPrerequisites_8h.html#a12507ffbcb05d7b7af41403ff7db8a5c">_OgrePagingExport</a> <a class="code" href="classOgre_1_1PagedWorldSection.html" title="Represents a section of the PagedWorld which uses a given PageStrategy, and which is made up of a gen...">PagedWorldSection</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">PageAlloc</a>
<a name="l00070"></a>00070     {
<a name="l00071"></a>00071     <span class="keyword">public</span>:
<a name="l00072"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a360be395b1e578acdeecbaee380a4621">00072</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;PageID, Page*&gt;::type</a> <a class="code" href="classOgre_1_1PagedWorldSection.html#a360be395b1e578acdeecbaee380a4621">PageMap</a>;
<a name="l00073"></a>00073     <span class="keyword">protected</span>:
<a name="l00074"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a79258d8d4ca24a32fc8de6fc31e80a55">00074</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1PagedWorldSection.html#a79258d8d4ca24a32fc8de6fc31e80a55">mName</a>;
<a name="l00075"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a1dfead55ae834be444f20c036cc935c4">00075</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1PagedWorldSection.html#a1dfead55ae834be444f20c036cc935c4">mAABB</a>;
<a name="l00076"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a0d9ca1368dc53f52578f227c4f93b34d">00076</a>         <a class="code" href="classOgre_1_1PagedWorld.html" title="This class represents a collection of pages which make up a world.">PagedWorld</a>* <a class="code" href="classOgre_1_1PagedWorldSection.html#a0d9ca1368dc53f52578f227c4f93b34d">mParent</a>;
<a name="l00077"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a2c949edb7e74ef43449c862d750dd6a0">00077</a>         <a class="code" href="classOgre_1_1PageStrategy.html" title="Defines the interface to a strategy class which is responsible for deciding when Page instances are r...">PageStrategy</a>* <a class="code" href="classOgre_1_1PagedWorldSection.html#a2c949edb7e74ef43449c862d750dd6a0">mStrategy</a>;
<a name="l00078"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a941352944ffee2c9e6e3e815ce7aaab0">00078</a>         <a class="code" href="classOgre_1_1PageStrategyData.html" title="Abstract marker class representing the data held against the PagedWorldSection which is specifically ...">PageStrategyData</a>* <a class="code" href="classOgre_1_1PagedWorldSection.html#a941352944ffee2c9e6e3e815ce7aaab0">mStrategyData</a>;
<a name="l00079"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a9b531d778e8adc14afd3447a121bd74b">00079</a>         <a class="code" href="classOgre_1_1PagedWorldSection.html#a360be395b1e578acdeecbaee380a4621">PageMap</a> <a class="code" href="classOgre_1_1PagedWorldSection.html#a9b531d778e8adc14afd3447a121bd74b">mPages</a>;
<a name="l00080"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a8696d7910a6f92f3cf0641d647547f89">00080</a>         <a class="code" href="classOgre_1_1PageProvider.html" title="Abstract class that can be implemented by the user application to provide a way to retrieve or genera...">PageProvider</a>* <a class="code" href="classOgre_1_1PagedWorldSection.html#a8696d7910a6f92f3cf0641d647547f89">mPageProvider</a>;
<a name="l00081"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a9a371ddcd8d33d0aaa1a556561e8c93e">00081</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* <a class="code" href="classOgre_1_1PagedWorldSection.html#a9a371ddcd8d33d0aaa1a556561e8c93e">mSceneMgr</a>;
<a name="l00082"></a>00082 
<a name="l00084"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a1e0bd0bc5e6b4ee1f6791544558a8568">00084</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1PagedWorldSection.html#a1e0bd0bc5e6b4ee1f6791544558a8568" title="Load data specific to a subtype of this class (if any)">loadSubtypeData</a>(<a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>&amp; ser) {}
<a name="l00085"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a791b04a967032522043e812384e5ce98">00085</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1PagedWorldSection.html#a791b04a967032522043e812384e5ce98">saveSubtypeData</a>(<a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>&amp; ser) {}
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088     <span class="keyword">public</span>:
<a name="l00089"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a10f86869b319e962411835604857909d">00089</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1PagedWorldSection.html#a10f86869b319e962411835604857909d">CHUNK_ID</a>;
<a name="l00090"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a95709472b243e346dd0be46b05927beb">00090</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1PagedWorldSection.html#a95709472b243e346dd0be46b05927beb">CHUNK_VERSION</a>;
<a name="l00091"></a>00091 
<a name="l00093"></a>00093         <a class="code" href="classOgre_1_1PagedWorldSection.html" title="Represents a section of the PagedWorld which uses a given PageStrategy, and which is made up of a gen...">PagedWorldSection</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="classOgre_1_1PagedWorld.html" title="This class represents a collection of pages which make up a world.">PagedWorld</a>* parent, <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* sm);
<a name="l00094"></a>00094         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1PagedWorldSection.html" title="Represents a section of the PagedWorld which uses a given PageStrategy, and which is made up of a gen...">PagedWorldSection</a>();
<a name="l00095"></a>00095 
<a name="l00096"></a>00096         <a class="code" href="classOgre_1_1PageManager.html" title="The PageManager is the entry point through which you load all PagedWorld instances, and the place where PageStrategy instances and factory classes are registered to customise the paging behaviour.">PageManager</a>* getManager() <span class="keyword">const</span>;
<a name="l00097"></a>00097 
<a name="l00099"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#ab9d51b4a80d2529909d00fcc801710d0">00099</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1PagedWorldSection.html#ab9d51b4a80d2529909d00fcc801710d0" title="Get the name of this section.">getName</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00101"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#acc11c9f5688b4571c06a65347e5cc792">00101</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1PageStrategy.html" title="Defines the interface to a strategy class which is responsible for deciding when Page instances are r...">PageStrategy</a>* <a class="code" href="classOgre_1_1PagedWorldSection.html#acc11c9f5688b4571c06a65347e5cc792" title="Get the page strategy which this section is using.">getStrategy</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mStrategy; }
<a name="l00107"></a>00107         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setStrategy(<a class="code" href="classOgre_1_1PageStrategy.html" title="Defines the interface to a strategy class which is responsible for deciding when Page instances are r...">PageStrategy</a>* strat);
<a name="l00113"></a>00113         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setStrategy(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; stratName);
<a name="l00114"></a>00114 
<a name="l00120"></a>00120         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSceneManager(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* sm);
<a name="l00121"></a>00121         
<a name="l00128"></a>00128         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSceneManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; smName);
<a name="l00130"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a963ba17393ce6e6592f76f136cfe6c1f">00130</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* <a class="code" href="classOgre_1_1PagedWorldSection.html#a963ba17393ce6e6592f76f136cfe6c1f" title="Get the current SceneManager.">getSceneManager</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSceneMgr; }
<a name="l00131"></a>00131 
<a name="l00133"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a42a167a881f5bcd4e9f8e172f94193b2">00133</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1PagedWorld.html" title="This class represents a collection of pages which make up a world.">PagedWorld</a>* <a class="code" href="classOgre_1_1PagedWorldSection.html#a42a167a881f5bcd4e9f8e172f94193b2" title="Get the parent world.">getWorld</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParent; }
<a name="l00135"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#aeb098522bb4d4a80627ba7a0ce062523">00135</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1PageStrategyData.html" title="Abstract marker class representing the data held against the PagedWorldSection which is specifically ...">PageStrategyData</a>* <a class="code" href="classOgre_1_1PagedWorldSection.html#aeb098522bb4d4a80627ba7a0ce062523" title="Get the data required by the PageStrategy which is specific to this world section.">getStrategyData</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mStrategyData; }
<a name="l00137"></a>00137         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setBoundingBox(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box);
<a name="l00139"></a>00139         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox() <span class="keyword">const</span>;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00143"></a>00143         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> load(<a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>&amp; stream);
<a name="l00145"></a>00145         <span class="keyword">virtual</span> <span class="keywordtype">void</span> save(<a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>&amp; stream);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00149"></a>00149         <span class="keyword">virtual</span> <span class="keywordtype">void</span> frameStart(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timeSinceLastFrame);
<a name="l00151"></a>00151         <span class="keyword">virtual</span> <span class="keywordtype">void</span> frameEnd(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timeElapsed);
<a name="l00153"></a>00153         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00154"></a>00154 
<a name="l00162"></a>00162         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Page.html" title="Page class.">Page</a>* loadOrCreatePage(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; worldPos);
<a name="l00163"></a>00163 
<a name="l00165"></a>00165         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a5126a9c9fbccbfe4c78070263098acb2" title="Identifier for a page.">PageID</a> getPageID(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; worldPos);
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00178"></a>00178         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadPage(<a class="code" href="namespaceOgre.html#a5126a9c9fbccbfe4c78070263098acb2" title="Identifier for a page.">PageID</a> pageID, <span class="keywordtype">bool</span> forceSynchronous = <span class="keyword">false</span>);
<a name="l00179"></a>00179 
<a name="l00187"></a>00187         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unloadPage(<a class="code" href="namespaceOgre.html#a5126a9c9fbccbfe4c78070263098acb2" title="Identifier for a page.">PageID</a> pageID, <span class="keywordtype">bool</span> forceSynchronous = <span class="keyword">false</span>);
<a name="l00195"></a>00195         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unloadPage(<a class="code" href="classOgre_1_1Page.html" title="Page class.">Page</a>* p, <span class="keywordtype">bool</span> forceSynchronous = <span class="keyword">false</span>);
<a name="l00203"></a>00203         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> _prepareProceduralPage(<a class="code" href="classOgre_1_1Page.html" title="Page class.">Page</a>* page);
<a name="l00211"></a>00211         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> _loadProceduralPage(<a class="code" href="classOgre_1_1Page.html" title="Page class.">Page</a>* page);
<a name="l00219"></a>00219         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> _unloadProceduralPage(<a class="code" href="classOgre_1_1Page.html" title="Page class.">Page</a>* page);
<a name="l00227"></a>00227         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> _unprepareProceduralPage(<a class="code" href="classOgre_1_1Page.html" title="Page class.">Page</a>* page);
<a name="l00228"></a>00228 
<a name="l00242"></a>00242         <span class="keyword">virtual</span> <span class="keywordtype">void</span> holdPage(<a class="code" href="namespaceOgre.html#a5126a9c9fbccbfe4c78070263098acb2" title="Identifier for a page.">PageID</a> pageID);
<a name="l00243"></a>00243 
<a name="l00249"></a>00249         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Page.html" title="Page class.">Page</a>* getPage(<a class="code" href="namespaceOgre.html#a5126a9c9fbccbfe4c78070263098acb2" title="Identifier for a page.">PageID</a> pageID);
<a name="l00250"></a>00250 
<a name="l00255"></a>00255         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllPages();
<a name="l00256"></a>00256 
<a name="l00268"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a4d4ad3e43086dcef834c14f5943ed906">00268</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1PagedWorldSection.html#a4d4ad3e43086dcef834c14f5943ed906" title="Set the PageProvider which can provide streams Pages in this section.">setPageProvider</a>(<a class="code" href="classOgre_1_1PageProvider.html" title="Abstract class that can be implemented by the user application to provide a way to retrieve or genera...">PageProvider</a>* provider) { mPageProvider = provider; }
<a name="l00269"></a>00269         
<a name="l00271"></a><a class="code" href="classOgre_1_1PagedWorldSection.html#a7e1c8daa7433709fcbfec8db8c2eed94">00271</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1PageProvider.html" title="Abstract class that can be implemented by the user application to provide a way to retrieve or genera...">PageProvider</a>* <a class="code" href="classOgre_1_1PagedWorldSection.html#a7e1c8daa7433709fcbfec8db8c2eed94" title="Get the PageProvider which can provide streams for Pages in this section.">getPageProvider</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPageProvider; }
<a name="l00272"></a>00272 
<a name="l00279"></a>00279         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>* _readPageStream(<a class="code" href="namespaceOgre.html#a5126a9c9fbccbfe4c78070263098acb2" title="Identifier for a page.">PageID</a> pageID);
<a name="l00280"></a>00280 
<a name="l00287"></a>00287         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>* _writePageStream(<a class="code" href="namespaceOgre.html#a5126a9c9fbccbfe4c78070263098acb2" title="Identifier for a page.">PageID</a> pageID);
<a name="l00288"></a>00288 
<a name="l00291"></a>00291         <a class="code" href="OgrePagingPrerequisites_8h.html#a12507ffbcb05d7b7af41403ff7db8a5c">_OgrePagingExport</a> <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator &lt;&lt;</a>( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PagedWorldSection.html" title="Represents a section of the PagedWorld which uses a given PageStrategy, and which is made up of a gen...">PagedWorldSection</a>&amp; p );
<a name="l00292"></a>00292 
<a name="l00294"></a>00294         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType();
<a name="l00295"></a>00295 
<a name="l00296"></a>00296     };
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 
<a name="l00301"></a><a class="code" href="classOgre_1_1PagedWorldSectionFactory.html">00301</a>     <span class="keyword">class </span><a class="code" href="OgrePagingPrerequisites_8h.html#a12507ffbcb05d7b7af41403ff7db8a5c">_OgrePagingExport</a> <a class="code" href="classOgre_1_1PagedWorldSectionFactory.html" title="A factory class for creating types of world section.">PagedWorldSectionFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">PageAlloc</a>
<a name="l00302"></a>00302     {
<a name="l00303"></a>00303     <span class="keyword">public</span>:
<a name="l00304"></a><a class="code" href="classOgre_1_1PagedWorldSectionFactory.html#a538fb98cfc2b5a3d32629c5927e56321">00304</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1PagedWorldSectionFactory.html#a538fb98cfc2b5a3d32629c5927e56321">~PagedWorldSectionFactory</a>() {}
<a name="l00305"></a>00305         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName() <span class="keyword">const</span> = 0;
<a name="l00306"></a>00306         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1PagedWorldSection.html" title="Represents a section of the PagedWorld which uses a given PageStrategy, and which is made up of a gen...">PagedWorldSection</a>* createInstance(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="classOgre_1_1PagedWorld.html" title="This class represents a collection of pages which make up a world.">PagedWorld</a>* parent, <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* sm) = 0;
<a name="l00307"></a>00307         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyInstance(<a class="code" href="classOgre_1_1PagedWorldSection.html" title="Represents a section of the PagedWorld which uses a given PageStrategy, and which is made up of a gen...">PagedWorldSection</a>*) = 0;
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310     };
<a name="l00311"></a>00311 
<a name="l00314"></a>00314 }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
